* don't exit initscript before citadelserver is gone.
[citadel.git] / citadel / debian / citadel.init
1 #! /bin/sh
2 ### BEGIN INIT INFO
3 # Provides:          skeleton
4 # Required-Start:    $local_fs $remote_fs
5 # Required-Stop:     $local_fs $remote_fs
6 # Default-Start:     2 3 4 5
7 # Default-Stop:      0 1 6
8 # Short-Description: Example initscript
9 # Description:       This file should be used to construct scripts to be
10 #                    placed in /etc/init.d.
11 ### END INIT INFO
12
13 # Author: Foo Bar <foobar@baz.org>
14 #
15 # Please remove the "Author" lines above and replace them
16 # with your own name if you copy and modify this script.
17
18 # Do NOT "set -e"
19
20 # PATH should only include /usr/* if it runs after the mountnfs.sh script
21 RUNDIR=/var/run/citadel
22 PATH=/sbin:/usr/sbin:/bin:/usr/bin
23 DESC="Citadel Groupware "
24 NAME=citserver
25 DAEMON=/usr/sbin/$NAME
26 CTDLSVC=/usr/lib/citadel-server/ctdlsvc
27 DAEMON_ARGS=" -x3 -lmail -t/dev/null"
28 PIDFILE=$RUNDIR/$NAME.pid
29 SCRIPTNAME=/etc/init.d/citadel
30 SENDCOMMAND=/usr/sbin/sendcommand
31
32
33 # Exit if the package is not installed
34 [ -x "$DAEMON" ] || exit 0
35
36 # Read configuration variable file if it is present
37 [ -r /etc/default/$NAME ] && . /etc/default/$NAME
38
39 # Load the VERBOSE setting and other rcS variables
40 . /lib/init/vars.sh
41
42 # Define LSB log_* functions.
43 # Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
44 . /lib/lsb/init-functions
45
46 #
47 # Function that starts the daemon/service
48 #
49 do_start()
50 {
51         # for ubuntu: check our volatile dirs.
52         if test ! -d $RUNDIR; then
53             mkdir -p $RUNDIR
54         fi
55         # Return
56         #   0 if daemon has been started
57         #   1 if daemon was already running
58         #   2 if daemon could not be started
59         if $CTDLSVC $PIDFILE $DAEMON \
60                 $DAEMON_ARGS ; then
61             return 0
62         else
63             return 2
64         fi
65         # Add code here, if necessary, that waits for the process to be ready
66         # to handle requests from services started subsequently which depend
67         # on this one.  As a last resort, sleep for some time.
68 }
69
70 #
71 # Function that stops the daemon/service
72 #
73 do_stop()
74 {
75         # Return
76         #   0 if daemon has been stopped
77         #   1 if daemon was already stopped
78         #   2 if daemon could not be stopped
79         #   other if a failure occurred
80         if $SENDCOMMAND "DOWN" >/dev/null 2>&1 ; then
81             rm -f $PIDFILE
82
83             while test -S /var/run/citadel/citadel.socket; do 
84                 sleep 1
85                 echo -n "."
86             done
87                 return 0
88         else
89             rm -f $PIDFILE
90             return 2
91         fi
92
93         #while test -d /proc/`cat $PIDFILE`; do
94         #    /usr/bin/printf  '.'
95         #    /bin/sleep 1
96         #done
97  
98         #start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
99         #RETVAL="$?"
100         #[ "$RETVAL" = 2 ] && return 2
101         # Wait for children to finish too if this is a daemon that forks
102         # and if the daemon is only ever run from this initscript.
103         # If the above conditions are not satisfied then add some other code
104         # that waits for the process to drop all resources that could be
105         # needed by services started subsequently.  A last resort is to
106         # sleep for some time.
107         #start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
108         #[ "$?" = 2 ] && return 2
109         # Many daemons don't delete their pidfiles when they exit.
110         # rm -f $PIDFILE
111 }
112
113 #
114 # Function that sends a SIGHUP to the daemon/service
115 #
116 do_reload() {
117         #
118         # If the daemon can reload its configuration without
119         # restarting (for example, when it is sent a SIGHUP),
120         # then implement that here.
121         #
122 #       start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
123         do_stop
124         do_start
125         return 0
126 }
127
128 case "$1" in
129   start)
130         [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
131         do_start
132         case "$?" in
133                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
134                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
135         esac
136         ;;
137   stop)
138         [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
139         do_stop
140         case "$?" in
141                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
142                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
143         esac
144         ;;
145   #reload|force-reload)
146         #
147         # If do_reload() is not implemented then leave this commented out
148         # and leave 'force-reload' as an alias for 'restart'.
149         #
150         #log_daemon_msg "Reloading $DESC" "$NAME"
151         #do_reload
152         #log_end_msg $?
153         #;;
154   restart|force-reload)
155         #
156         # If the "reload" option is implemented then remove the
157         # 'force-reload' alias
158         #
159         log_daemon_msg "Restarting $DESC" "$NAME"
160         do_stop
161         case "$?" in
162           0|1)
163                 do_start
164                 case "$?" in
165                         0) log_end_msg 0 ;;
166                         1) log_end_msg 1 ;; # Old process is still running
167                         *) log_end_msg 1 ;; # Failed to start
168                 esac
169                 ;;
170           *)
171                 # Failed to stop
172                 log_end_msg 1
173                 ;;
174         esac
175         ;;
176   *)
177         #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
178         echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
179         exit 3
180         ;;
181 esac
182
183 :